/// @description Setup basic player variables and behaviour

//movement buttons
left = global.button0;
right = global.button1;
jump = global.button2;
drop = global.button3;

//gravity
gravity_direction = 270;
baseGravity = 0.5;
gravity = baseGravity;

//other variables
coins = 0;
onGround = false;					//wether the player is on solid ground
baseHSpeed = 4;						//base maximum horizontal speed
maxHSpeed = baseHSpeed;				//maximum horizontal speed
minHSpeed = 1;						//minimum speed
hAcceleration = 0.6;				//horizontal acceleration
hFriction = 1.5;					//friction when slowing down
maxVSpeed = 20;						//maximum vertical speed
jumpForce = -8;						//initial jumping speed
jumpPrecision = 1.1;				//how much to slow down when letting go of jump
jumpBufferFrames = 5;				//you can jump for this many frames after going airborne
OOBMargin = 100;					//being this many pixels out of bounds is deadly
isGrappling = false;				//wether the player is currently swinging
pivot = -1;							//target pivot point for grapple swing
targetGrapplingDistance = 100;		//the grappling distance to smooth to
grapplingDistance = 0;				//the distance to keep from the grappling target
currentAngle = 0;					//current grappling hook angle
coinSlowDown = 0.4;					//the amount one coin slows down the player
isFading = 0;						//wether the player is in a fade animation
playedSound = 0;					//coinlock locked sound
jumpPadForce = -18;					//jump force of jump pads
padJump = 0;						//wether the last jump was from a jump pad
destroyOK = 0;						//destroy wont trigger a death
canReset = 1;						//wether the player can reset
ending = 0;							//which ending to trigger
updates = 1;

grappleSine = 0;					//tbh i forgot

//setup camera
if (!instance_exists(obj_camera)) {
	instance_create_layer(x, y, "tech", obj_camera);
}

if (!instance_exists(obj_gui)) {
	instance_create_layer(0, 0, "foreground", obj_gui);
}

if (!instance_exists(obj_mouse)) {
	instance_create_layer(0, 0, "foreground", obj_mouse);
	instance_create_layer(0, 0, "foreground", obj_mouse_inner);
}

//slowdown if restarted
if (global.coinCount != 0) {
	scr_calculateNewPlayerSpeed();
}

//respawn on save
if (global.spawnX != 0 && global.spawnY != 0) {
	x = global.spawnX;
	y = global.spawnY;
	
	global.spawnX = 0;
	global.spawnY = 0;
}